package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class ClassNameExact extends ClassNameGlob {
  protected ClassName classname;
  public ClassName get_classname() { return classname; }
  public void set_classname(ClassName new_classname) { classname = new_classname; }
  public ClassNameExact() { super(); }
  public ClassNameExact(ClassName classname) {
    super();
    set_classname(classname);
  }
  public static ClassNameExact parse(java.io.Reader in) throws ParseException { return new Parser(in)._ClassNameExact(); }
  public static ClassNameExact parse(java.io.InputStream in) throws ParseException { return new Parser(in)._ClassNameExact(); }
  public static ClassNameExact parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  public String toString() { return classname.toString(); }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_classname(this, classname);
    classname.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_classname(this, classname);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

  void __trav_matchEdge_GlobSpec_trv_bef(__V_GlobSpec_matchEdge __v0) {
    super.__trav_matchEdge_GlobSpec_trv_bef(__v0);
  }

  void __trav_matchEdge_GlobSpec_trv_aft(__V_GlobSpec_matchEdge __v0) {
    super.__trav_matchEdge_GlobSpec_trv_aft(__v0);
  }

  void __trav_matchEdge_GlobSpec_trv(__V_GlobSpec_matchEdge __v0) {
    __trav_matchEdge_GlobSpec_trv_bef(__v0);
    classname.__trav_matchEdge_GlobSpec_trv(__v0);
    __trav_matchEdge_GlobSpec_trv_aft(__v0);
  }

  void __trav_match_GlobSpec_trv_bef(__V_GlobSpec_match __v0) {
    super.__trav_match_GlobSpec_trv_bef(__v0);
  }

  void __trav_match_GlobSpec_trv_aft(__V_GlobSpec_match __v0) {
    super.__trav_match_GlobSpec_trv_aft(__v0);
  }

  void __trav_match_GlobSpec_trv(java.util.BitSet nodes, __V_GlobSpec_match __v0) {
    __trav_match_GlobSpec_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(1);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        classname.__trav_match_GlobSpec_trv(newnodes, __v0);
      }
    }
    __trav_match_GlobSpec_trv_aft(__v0);
  }

  void __trav_match_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_match __v0) {
    super.__trav_match_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_match_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_match __v0) {
    super.__trav_match_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_match_ClassGlobSpec_trv(java.util.BitSet nodes, __V_ClassGlobSpec_match __v0) {
    __trav_match_ClassGlobSpec_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(1);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        classname.__trav_match_ClassGlobSpec_trv(newnodes, __v0);
      }
    }
    __trav_match_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_map_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_map __v0) {
    super.__trav_map_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_map_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_map __v0) {
    super.__trav_map_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_map_ClassGlobSpec_trv(__V_ClassGlobSpec_map __v0) {
    __trav_map_ClassGlobSpec_trv_bef(__v0);
    classname.__trav_map_ClassGlobSpec_trv(__v0);
    __trav_map_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_addStrings __v0) {
    super.__trav_addStrings_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_addStrings __v0) {
    super.__trav_addStrings_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv(__V_ClassGlobSpec_addStrings __v0) {
    __trav_addStrings_ClassGlobSpec_trv_bef(__v0);
    classname.__trav_addStrings_ClassGlobSpec_trv(__v0);
    __trav_addStrings_ClassGlobSpec_trv_aft(__v0);
  }

}
